/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2012, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) Copyright (C) 2003-2012 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
///////////////////////////////////////////////////////////////////////////////

#ifndef DbAssocEdgePersSubentId_INCLUDED_
#define DbAssocEdgePersSubentId_INCLUDED_ /* {Secret} */

#include "DbConstraintsExports.h"

#include "OdArray.h"
#include "SmartPtr.h"
#include "DbSubentId.h"
#include "DbAssocPersSubentId.h"

class OdDbAssocEdgePersSubentId;
typedef OdSmartPtr<OdDbAssocEdgePersSubentId> OdDbAssocEdgePersSubentIdPtr;

#include "TD_PackPush.h"


class DBCONSTRAINTS_EXPORT OdDbAssocEdgePersSubentId : public OdDbAssocPersSubentId
{
public:
	ODRX_DECLARE_MEMBERS(OdDbAssocEdgePersSubentId);

  OdDbAssocEdgePersSubentId();

  void init(int vertexIdentifier1, int vertexIdentifier2);

  virtual int transientSubentCount(const OdDbEntity* pEntity) const { return !isNull() ? 1 : 0; }

  virtual OdDb::SubentType subentType(const OdDbEntity* pEntity) const;

  virtual bool isNull() const { return m_index1 == 0; }

  virtual bool isEqualTo(const OdDbEntity* pEntity, const OdDbAssocPersSubentId* pOther) const
  {
    if (!OdDbAssocPersSubentId::isEqualTo(pEntity, pOther))
      return false;

    OdDbAssocEdgePersSubentIdPtr pOtherEdge = pOther;
    return !pOtherEdge.isNull() && ((m_index1 == pOtherEdge->m_index1) && (m_index2== pOtherEdge->m_index2));
  }

  virtual OdResult dwgOutFields(OdDbDwgFiler* pFiler) const;
  virtual OdResult dwgInFields(OdDbDwgFiler* pFiler);

  virtual void dxfOutFields(OdDbDxfFiler* pFiler) const;
  virtual OdResult dxfInFields(OdDbDxfFiler* pFiler);

  //virtual OdResult audit(OdDbAuditInfo* pAuditInfo);

  OdGsMarker index1() const { return m_index1; }
  OdGsMarker index2() const { return m_index2; }

private:
  OdGsMarker  m_index1;
  OdGsMarker  m_index2;

  bool m_Unk_Bool_1;

};

#include "TD_PackPop.h"

#endif