/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2011, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) for .dwg files Copyright (C) 2003-2011 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
//
//
// *DWG is the native and proprietary file format for AutoCAD(R) and a trademark  
// of Autodesk, Inc.  Open Design Alliance is not associated with Autodesk.
///////////////////////////////////////////////////////////////////////////////
#ifndef OdDbAssocPersSubentIdPE_INCLUDED_
#define OdDbAssocPersSubentIdPE_INCLUDED_ /* {Secret} */

#include "DbAssocPersSubentId.h"
#include "Ge/GePoint3d.h"
#include "Ge/GeCurve3d.h"

#include "TD_PackPush.h"

/*
struct OdDbAssocTransInfo
{
  enum TransType
  {
    kGeneral = 0,
    kScaling,
    kRadius,
    kMajorRadius,
    kMinorRadius,
    kFixedRadius,
    kFixed,
    kFixWhenPossible,
    kNone,
  };

  OdDbAssocTransInfo() : mRadius(-1.0), mTransType(kGeneral)
  {}
  TransType mTransType;

  OdGeMatrix3d mTrans;

  double mRadius;
};


struct OdDbAssocSubentTransInfo : OdDbAssocTransInfo
{
  OdDbSubentId mSubentId;
};
*/

enum RigidSetType
{
  kNotRigidSet = 0,
  kScalableRigidSet,
  kNonScalableRigidSet
};


class DBCONSTRAINTS_EXPORT OdDbAssocPersSubentIdPE : public OdRxObject
{
public:
	ODRX_DECLARE_MEMBERS(OdDbAssocPersSubentIdPE);

  virtual OdDbAssocPersSubentIdPtr createNewPersSubent(OdDbEntity* pEntity,
                                                     const class OdDbCompoundObjectId& compId,
                                                     const OdDbSubentId& subentId)
  {
      OdDbAssocSimplePersSubentIdPtr res = OdDbAssocSimplePersSubentId::createObject();
      res->init(subentId);
      return res;
  }

  virtual OdResult getTransientSubentIds(const OdDbEntity* pEntity, 
                                         const OdDbAssocPersSubentId* pPerSubentId,
                                         OdArray<OdDbSubentId>& subents) const = 0;

  virtual OdResult getAllSubentities(const OdDbEntity* pEntity,
                                     OdDb::SubentType subentType,
                                     OdArray<OdDbSubentId>& allSubentIds)
  {
      return eNotImplemented;
  }

  virtual OdResult getEdgeVertexSubentities(const OdDbEntity*      pEntity,
                                            const OdDbSubentId&    edgeSubentId,
                                            OdDbSubentId&          startVertexSubentId,
                                            OdDbSubentId&          endVertexSubentId,
                                            OdArray<OdDbSubentId>& otherVertexSubentIds)
  {
      return eNotImplemented;
  }


  virtual OdResult getSplineEdgeVertexSubentities(const OdDbEntity*      pEntity,
                                                  const OdDbSubentId&    edgeSubentId,
                                                  OdDbSubentId&          startVertexSubentId,
                                                  OdDbSubentId&          endVertexSubentId,
                                                  OdArray<OdDbSubentId>& controlPointSubentIds,
                                                  OdArray<OdDbSubentId>& fitPointSubentIds)
  {
      return eNotImplemented;
  }

  virtual OdResult getVertexSubentityGeometry(const OdDbEntity*   pEntity,
                                              const OdDbSubentId& vertexSubentId,
                                              OdGePoint3d&        vertexPosition)
  {
      return eNotImplemented;
  }

  virtual OdResult getEdgeSubentityGeometry(const OdDbEntity*   pEntity,
                                            const OdDbSubentId& edgeSubentId,
                                            OdGeCurve3d*&       pEdgeCurve)
  {
      return eNotImplemented;
  }

  virtual OdResult getFaceSubentityGeometry(const OdDbEntity*   pEntity,
                                            const OdDbSubentId& faceSubentId,
                                            OdGeSurface*&       pFaceSurface)
  {
      return eNotImplemented;
  }

  virtual OdResult setVertexSubentityGeometry(OdDbEntity*         pEntity,
                                              const OdDbSubentId& vertexSubentId,
                                              const OdGePoint3d&  newVertexPosition)
  {
      return eNotImplemented;
  }

  virtual OdResult setEdgeSubentityGeometry(OdDbEntity*         pEntity,
                                            const OdDbSubentId& edgeSubentId,
                                            const OdGeCurve3d*  pNewEdgeCurve)
  {
      return eNotImplemented;
  }

  virtual OdResult setFaceSubentityGeometry(OdDbEntity*         pEntity,
                                            const OdDbSubentId& faceSubentId,
                                            const OdGeSurface*  pNewFaceSurface)
  {
      return eNotImplemented;
  }

  virtual OdResult setSubentityGeometry(OdDbEntity*         pEntity,
                                        const OdDbSubentId& subentId,
                                        const OdDbEntity*   pNewSubentityGeometry)
  {
      return eNotImplemented;
  }

  ///Tese methods are deprecated and should not be used.
  /*
  virtual OdResult getSubentTransFromStretchPoints(const OdDbEntity*   pEntity,
                                                   const OdDbIntArray& indices, 
                                                   const OdGeVector3d& offset,
                                                   OdArray<OdDbAssocSubentTransInfo>& aSubentTransInfos) const
  {
    return eNotImplemented;
  }

  virtual OdResult getSubentTransFromGripPoints(const OdDbEntity*   pEntity,
                                                         const OdDbIntArray& indices, 
                                                         const OdGeVector3d& offset,
                                                         AcArray<OdDbAssocSubentTransInfo>& aSubentTransInfos) const
  {
    return eNotImplemented;
  }

  virtual OdResult getSubentTransFromGripPoints(const OdDbEntity*       pEntity,
                                                         const OdDbVoidPtrArray& gripAppData, 
                                                         const OdGeVector3d&     offset,
                                                         AcArray<OdDbAssocSubentTransInfo>& aSubentTransInfos) const
  {
    return eNotImplemented;
  }
  */

  virtual OdResult getSubentGeometryXform(const OdDbEntity*        pEntity,
                                          const OdDbObjectIdArray& fullSubentPath,
                                          OdGeMatrix3d&            trans) const
  {
      trans.setToIdentity();
      return eOk;
  }

  virtual OdResult mirrorPersSubent(const OdDbEntity*      pMirroredEntity,
                                    OdDbAssocPersSubentId& persSubentIdToMirror)
  {
      return eOk;
  }

  virtual int getRigidSetState(const OdDbEntity* pEntity)
  {
    return kNotRigidSet;
  }

  virtual OdResult getRigidSetTransform(const OdDbEntity* pEntity,
                                        OdGeMatrix3d&     trans)
  {
      return eNotApplicable;
  }

  virtual OdResult setRigidSetTransform(OdDbEntity*         pEntity, 
                                        const OdGeMatrix3d& trans)
  {
      return eNotApplicable;
  }

}; // class OdDbAssocPersSubentIdPE

#include "TD_PackPop.h"
#endif


