/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2011, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) for .dwg files Copyright (C) 2003-2011 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
//
//
// *DWG is the native and proprietary file format for AutoCAD(R) and a trademark  
// of Autodesk, Inc.  Open Design Alliance is not associated with Autodesk.
///////////////////////////////////////////////////////////////////////////////

#ifndef OdImplicitConstr_INCLUDED
#define OdImplicitConstr_INCLUDED

#include "OdConstrainedGeometry.h"
#include "OdGeomConstraint.h"


#include "TD_PackPush.h"

class DBCONSTRAINTS_EXPORT OdPerpendicularConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdPerpendicularConstraint);

  OdPerpendicularConstraint();
};

class DBCONSTRAINTS_EXPORT OdNormalConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdNormalConstraint);

  OdNormalConstraint();
};

class DBCONSTRAINTS_EXPORT OdPointCurveConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdPointCurveConstraint);

  OdPointCurveConstraint();
};

class DBCONSTRAINTS_EXPORT OdColinearConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdColinearConstraint);

  OdColinearConstraint();
};

class DBCONSTRAINTS_EXPORT OdPointCoincidenceConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdPointCoincidenceConstraint);

  OdPointCoincidenceConstraint();
};

class DBCONSTRAINTS_EXPORT OdConcentricConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdConcentricConstraint);

  OdConcentricConstraint();
};

class DBCONSTRAINTS_EXPORT OdCenterPointConstraint: public OdConcentricConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdCenterPointConstraint);
};

class DBCONSTRAINTS_EXPORT OdTangentConstraint : public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdTangentConstraint);

  OdTangentConstraint();
};

class DBCONSTRAINTS_EXPORT OdEqualRadiusConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdEqualRadiusConstraint);

  OdEqualRadiusConstraint();
};

class DBCONSTRAINTS_EXPORT OdEqualDistanceConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdEqualDistanceConstraint);

  OdEqualDistanceConstraint();
};

class DBCONSTRAINTS_EXPORT OdEqualLengthConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdEqualLengthConstraint);

  OdEqualLengthConstraint();
};

class DBCONSTRAINTS_EXPORT OdParallelConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdParallelConstraint);

  OdParallelConstraint();
  OdParallelConstraint(bool createImpl);
};

class DBCONSTRAINTS_EXPORT OdHorizontalConstraint: public OdParallelConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdHorizontalConstraint);

  OdHorizontalConstraint();
};

class DBCONSTRAINTS_EXPORT OdVerticalConstraint: public OdParallelConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdVerticalConstraint);

  OdVerticalConstraint();
};

class DBCONSTRAINTS_EXPORT OdEqualCurvatureConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdEqualCurvatureConstraint);

  OdEqualCurvatureConstraint();
};


class DBCONSTRAINTS_EXPORT OdSymmetricConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdSymmetricConstraint);

  OdSymmetricConstraint();
};

class DBCONSTRAINTS_EXPORT OdMidPointConstraint: public OdGeomConstraint 
{ 
public:
  ODRX_DECLARE_MEMBERS(OdMidPointConstraint);

  OdMidPointConstraint();
};

class DBCONSTRAINTS_EXPORT OdFixedConstraint : public OdGeomConstraint
{
public:
  ODRX_DECLARE_MEMBERS(OdFixedConstraint);

  OdFixedConstraint();
};

class DBCONSTRAINTS_EXPORT OdG2SmoothConstraint : public OdCompositeConstraint
{
public:
  ODRX_DECLARE_MEMBERS(OdG2SmoothConstraint);

  OdG2SmoothConstraint();
};

#if 0 // TODO:
class DBCONSTRAINTS_EXPORT OdEqualHelpParameterConstraint : public OdGeomConstraint
{
public:
  ODRX_DECLARE_MEMBERS(OdEqualHelpParameterConstraint);

  OdEqualHelpParameterConstraint();

  OdResult getEqualHelpParameters(OdHelpParameter*& pHelpParameter1, OdHelpParameter*& pHelpParameter2) const;
};
#endif


#include "TD_PackPop.h"

#endif
